/* DEFS: message TCharmInitMsg{
char data[];
}
;
 */
#ifndef CK_TEMPLATES_ONLY
void *CMessage_TCharmInitMsg::operator new(size_t s){
  return TCharmInitMsg::alloc(__idx, s, 0, 0);
}
void *CMessage_TCharmInitMsg::operator new(size_t s, int* sz){
  return TCharmInitMsg::alloc(__idx, s, sz, 0);
}
void *CMessage_TCharmInitMsg::operator new(size_t s, int* sz,const int pb){
  return TCharmInitMsg::alloc(__idx, s, sz, pb);
}
void *CMessage_TCharmInitMsg::operator new(size_t s, int sz0) {
  int sizes[1];
  sizes[0] = sz0;
  return TCharmInitMsg::alloc(__idx, s, sizes, 0);
}
void *CMessage_TCharmInitMsg::operator new(size_t s, int sz0, const int p) {
  int sizes[1];
  sizes[0] = sz0;
  return TCharmInitMsg::alloc(__idx, s, sizes, p);
}
void* CMessage_TCharmInitMsg::alloc(int msgnum, size_t sz, int *sizes, int pb) {
  int offsets[2];
  offsets[0] = ALIGN8(sz);
  if(sizes==0)
    offsets[1] = offsets[0];
  else
    offsets[1] = offsets[0] + ALIGN8(sizeof(char)*sizes[0]);
  TCharmInitMsg *newmsg = (TCharmInitMsg *) CkAllocMsg(msgnum, offsets[1], pb);
  newmsg->data = (char *) ((char *)newmsg + offsets[0]);
  return (void *) newmsg;
}
void* CMessage_TCharmInitMsg::pack(TCharmInitMsg *msg) {
  msg->data = (char *) ((char *)msg->data - (char *)msg);
  return (void *) msg;
}
TCharmInitMsg* CMessage_TCharmInitMsg::unpack(void* buf) {
  TCharmInitMsg *msg = (TCharmInitMsg *) buf;
  msg->data = (char *) ((size_t)msg->data + (char *)msg);
  return msg;
}
int CMessage_TCharmInitMsg::__idx=0;
#endif

/* DEFS: array TCharm: ArrayElement{
TCharm(CkMigrateMessage* impl_msg);
TCharm(TCharmInitMsg* impl_msg);
void atBarrier(CkReductionMsg* impl_msg);
void atExit(CkReductionMsg* impl_msg);
void migrateDelayed(int destPE);
void start(void);
void callSystem(const callSystemStruct &s);
  initcall void procInit(void);
  initcall void nodeInit(void);
};
 */
#ifndef CK_TEMPLATES_ONLY
 int CkIndex_TCharm::__idx=0;
#endif
#ifndef CK_TEMPLATES_ONLY
/* DEFS: TCharm(CkMigrateMessage* impl_msg);
 */

/* DEFS: TCharm(TCharmInitMsg* impl_msg);
 */
void CProxyElement_TCharm::insert(TCharmInitMsg* impl_msg, int onPE)
{ 
   ckInsert((CkArrayMessage *)impl_msg,CkIndex_TCharm::__idx_TCharm_TCharmInitMsg,onPE);
}

/* DEFS: void atBarrier(CkReductionMsg* impl_msg);
 */
void CProxyElement_TCharm::atBarrier(CkReductionMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_TCharm::__idx_atBarrier_CkReductionMsg,0);
}

/* DEFS: void atExit(CkReductionMsg* impl_msg);
 */
void CProxyElement_TCharm::atExit(CkReductionMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_TCharm::__idx_atExit_CkReductionMsg,0);
}

/* DEFS: void migrateDelayed(int destPE);
 */
void CProxyElement_TCharm::migrateDelayed(int destPE, const CkEntryOptions *impl_e_opts) 
{
  ckCheck();
  //Marshall: int destPE
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    implP|destPE;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    implP|destPE;
  }
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_TCharm::__idx_migrateDelayed_marshall4,0);
}

/* DEFS: void start(void);
 */
void CProxyElement_TCharm::start(void) 
{
  ckCheck();
  void *impl_msg = CkAllocSysMsg();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_TCharm::__idx_start_void,0);
}

/* DEFS: void callSystem(const callSystemStruct &s);
 */
void CProxyElement_TCharm::callSystem(const callSystemStruct &s, const CkEntryOptions *impl_e_opts) 
{
  ckCheck();
  //Marshall: const callSystemStruct &s
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(callSystemStruct &)s;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(callSystemStruct &)s;
  }
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_TCharm::__idx_callSystem_marshall6,0);
}


/* DEFS: TCharm(CkMigrateMessage* impl_msg);
 */
 int CkIndex_TCharm::__idx_TCharm_CkMigrateMessage=0;
void CkIndex_TCharm::_call_TCharm_CkMigrateMessage(void* impl_msg,TCharm * impl_obj)
{
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  setMemoryStatus(1);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  new (impl_obj) TCharm((CkMigrateMessage*)impl_msg);
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(0);
#endif
}

/* DEFS: TCharm(TCharmInitMsg* impl_msg);
 */
CkArrayID CProxy_TCharm::ckNew(TCharmInitMsg* impl_msg, const CkArrayOptions &opts)
{ 
   return ckCreateArray((CkArrayMessage *)impl_msg,CkIndex_TCharm::__idx_TCharm_TCharmInitMsg,opts);
}
CkArrayID CProxy_TCharm::ckNew(TCharmInitMsg* impl_msg, const int s1)
{ 
   return ckCreateArray((CkArrayMessage *)impl_msg,CkIndex_TCharm::__idx_TCharm_TCharmInitMsg,CkArrayOptions(s1));
}
 int CkIndex_TCharm::__idx_TCharm_TCharmInitMsg=0;
void CkIndex_TCharm::_call_TCharm_TCharmInitMsg(void* impl_msg,TCharm * impl_obj)
{
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  setMemoryStatus(1);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  new (impl_obj) TCharm((TCharmInitMsg*)impl_msg);
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(0);
#endif
}

/* DEFS: void atBarrier(CkReductionMsg* impl_msg);
 */
void CProxy_TCharm::atBarrier(CkReductionMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckBroadcast(impl_amsg, CkIndex_TCharm::__idx_atBarrier_CkReductionMsg,0);
}
 int CkIndex_TCharm::__idx_atBarrier_CkReductionMsg=0;
void CkIndex_TCharm::_call_atBarrier_CkReductionMsg(void* impl_msg,TCharm * impl_obj)
{
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  setMemoryStatus(1);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  impl_obj->atBarrier((CkReductionMsg*)impl_msg);
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(0);
#endif
}

/* DEFS: void atExit(CkReductionMsg* impl_msg);
 */
void CProxy_TCharm::atExit(CkReductionMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckBroadcast(impl_amsg, CkIndex_TCharm::__idx_atExit_CkReductionMsg,0);
}
 int CkIndex_TCharm::__idx_atExit_CkReductionMsg=0;
void CkIndex_TCharm::_call_atExit_CkReductionMsg(void* impl_msg,TCharm * impl_obj)
{
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  setMemoryStatus(1);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  impl_obj->atExit((CkReductionMsg*)impl_msg);
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(0);
#endif
}

/* DEFS: void migrateDelayed(int destPE);
 */
void CProxy_TCharm::migrateDelayed(int destPE, const CkEntryOptions *impl_e_opts) 
{
  ckCheck();
  //Marshall: int destPE
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    implP|destPE;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    implP|destPE;
  }
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckBroadcast(impl_amsg, CkIndex_TCharm::__idx_migrateDelayed_marshall4,0);
}
 int CkIndex_TCharm::__idx_migrateDelayed_marshall4=0;
void CkIndex_TCharm::_call_migrateDelayed_marshall4(void* impl_msg,TCharm * impl_obj)
{
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: int destPE*/
  PUP::fromMem implP(impl_buf);
  int destPE; implP|destPE;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  setMemoryStatus(1);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  impl_obj->migrateDelayed(destPE);
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(0);
#endif
}
int CkIndex_TCharm::_callmarshall_migrateDelayed_marshall4(char* impl_buf,TCharm * impl_obj) {
  /*Unmarshall pup'd fields: int destPE*/
  PUP::fromMem implP(impl_buf);
  int destPE; implP|destPE;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  setMemoryStatus(1);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  impl_obj->migrateDelayed(destPE);
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(0);
#endif
  return implP.size();
}
void CkIndex_TCharm::_marshallmessagepup_migrateDelayed_marshall4(PUP::er &implDestP,void *impl_msg) {
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: int destPE*/
  PUP::fromMem implP(impl_buf);
  int destPE; implP|destPE;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  if (implDestP.hasComments()) implDestP.comment("destPE");
  implDestP|destPE;
}

/* DEFS: void start(void);
 */
void CProxy_TCharm::start(void) 
{
  ckCheck();
  void *impl_msg = CkAllocSysMsg();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckBroadcast(impl_amsg, CkIndex_TCharm::__idx_start_void,0);
}
 int CkIndex_TCharm::__idx_start_void=0;
void CkIndex_TCharm::_call_start_void(void* impl_msg,TCharm * impl_obj)
{
  CkFreeSysMsg(impl_msg);
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  setMemoryStatus(1);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  impl_obj->start();
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(0);
#endif
}

/* DEFS: void callSystem(const callSystemStruct &s);
 */
void CProxy_TCharm::callSystem(const callSystemStruct &s, const CkEntryOptions *impl_e_opts) 
{
  ckCheck();
  //Marshall: const callSystemStruct &s
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(callSystemStruct &)s;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(callSystemStruct &)s;
  }
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckBroadcast(impl_amsg, CkIndex_TCharm::__idx_callSystem_marshall6,0);
}
 int CkIndex_TCharm::__idx_callSystem_marshall6=0;
void CkIndex_TCharm::_call_callSystem_marshall6(void* impl_msg,TCharm * impl_obj)
{
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: const callSystemStruct &s*/
  PUP::fromMem implP(impl_buf);
  callSystemStruct s; implP|s;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  setMemoryStatus(1);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  impl_obj->callSystem(s);
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(0);
#endif
}
int CkIndex_TCharm::_callmarshall_callSystem_marshall6(char* impl_buf,TCharm * impl_obj) {
  /*Unmarshall pup'd fields: const callSystemStruct &s*/
  PUP::fromMem implP(impl_buf);
  callSystemStruct s; implP|s;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
#ifndef CMK_OPTIMIZE
  setMemoryChareID(impl_obj);
  setMemoryStatus(1);
#endif
#ifdef CMK_CHECK_CRC
  checkAllCRC(0);
#endif
  impl_obj->callSystem(s);
#ifdef CMK_CHECK_CRC
  checkAllCRC(1);
#endif
#ifndef CMK_OPTIMIZE
  setMemoryChareID(NULL);
  setMemoryStatus(0);
#endif
  return implP.size();
}
void CkIndex_TCharm::_marshallmessagepup_callSystem_marshall6(PUP::er &implDestP,void *impl_msg) {
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: const callSystemStruct &s*/
  PUP::fromMem implP(impl_buf);
  callSystemStruct s; implP|s;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  if (implDestP.hasComments()) implDestP.comment("s");
  implDestP|s;
}


/* DEFS: TCharm(CkMigrateMessage* impl_msg);
 */

/* DEFS: TCharm(TCharmInitMsg* impl_msg);
 */

/* DEFS: void atBarrier(CkReductionMsg* impl_msg);
 */
void CProxySection_TCharm::atBarrier(CkReductionMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_TCharm::__idx_atBarrier_CkReductionMsg,0);
}

/* DEFS: void atExit(CkReductionMsg* impl_msg);
 */
void CProxySection_TCharm::atExit(CkReductionMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_TCharm::__idx_atExit_CkReductionMsg,0);
}

/* DEFS: void migrateDelayed(int destPE);
 */
void CProxySection_TCharm::migrateDelayed(int destPE, const CkEntryOptions *impl_e_opts) 
{
  ckCheck();
  //Marshall: int destPE
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    implP|destPE;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    implP|destPE;
  }
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_TCharm::__idx_migrateDelayed_marshall4,0);
}

/* DEFS: void start(void);
 */
void CProxySection_TCharm::start(void) 
{
  ckCheck();
  void *impl_msg = CkAllocSysMsg();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_TCharm::__idx_start_void,0);
}

/* DEFS: void callSystem(const callSystemStruct &s);
 */
void CProxySection_TCharm::callSystem(const callSystemStruct &s, const CkEntryOptions *impl_e_opts) 
{
  ckCheck();
  //Marshall: const callSystemStruct &s
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(callSystemStruct &)s;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(callSystemStruct &)s;
  }
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_TCharm::__idx_callSystem_marshall6,0);
}


#endif /*CK_TEMPLATES_ONLY*/
#ifndef CK_TEMPLATES_ONLY
void CkIndex_TCharm::__register(const char *s, size_t size) {
  __idx = CkRegisterChare(s, size);
  CkRegisterBase(__idx, CkIndex_ArrayElement::__idx);
// REG: TCharm(CkMigrateMessage* impl_msg);
  __idx_TCharm_CkMigrateMessage = CkRegisterEp("TCharm(CkMigrateMessage* impl_msg)",
     (CkCallFnPtr)_call_TCharm_CkMigrateMessage, 0, __idx, 0);
  CkRegisterMigCtor(__idx, __idx_TCharm_CkMigrateMessage);

// REG: TCharm(TCharmInitMsg* impl_msg);
  __idx_TCharm_TCharmInitMsg = CkRegisterEp("TCharm(TCharmInitMsg* impl_msg)",
     (CkCallFnPtr)_call_TCharm_TCharmInitMsg, CMessage_TCharmInitMsg::__idx, __idx, 0);

// REG: void atBarrier(CkReductionMsg* impl_msg);
  __idx_atBarrier_CkReductionMsg = CkRegisterEp("atBarrier(CkReductionMsg* impl_msg)",
     (CkCallFnPtr)_call_atBarrier_CkReductionMsg, CMessage_CkReductionMsg::__idx, __idx, 0);

// REG: void atExit(CkReductionMsg* impl_msg);
  __idx_atExit_CkReductionMsg = CkRegisterEp("atExit(CkReductionMsg* impl_msg)",
     (CkCallFnPtr)_call_atExit_CkReductionMsg, CMessage_CkReductionMsg::__idx, __idx, 0);

// REG: void migrateDelayed(int destPE);
  __idx_migrateDelayed_marshall4 = CkRegisterEp("migrateDelayed(int destPE)",
     (CkCallFnPtr)_call_migrateDelayed_marshall4, CkMarshallMsg::__idx, __idx, 0+CK_EP_NOKEEP);
  CkRegisterMarshallUnpackFn(__idx_migrateDelayed_marshall4,(CkMarshallUnpackFn)_callmarshall_migrateDelayed_marshall4);
  CkRegisterMessagePupFn(__idx_migrateDelayed_marshall4,(CkMessagePupFn)_marshallmessagepup_migrateDelayed_marshall4);

// REG: void start(void);
  __idx_start_void = CkRegisterEp("start(void)",
     (CkCallFnPtr)_call_start_void, 0, __idx, 0);

// REG: void callSystem(const callSystemStruct &s);
  __idx_callSystem_marshall6 = CkRegisterEp("callSystem(const callSystemStruct &s)",
     (CkCallFnPtr)_call_callSystem_marshall6, CkMarshallMsg::__idx, __idx, 0+CK_EP_NOKEEP);
  CkRegisterMarshallUnpackFn(__idx_callSystem_marshall6,(CkMarshallUnpackFn)_callmarshall_callSystem_marshall6);
  CkRegisterMessagePupFn(__idx_callSystem_marshall6,(CkMessagePupFn)_marshallmessagepup_callSystem_marshall6);

      _registerInitCall(TCharm::procInit,0);

      _registerInitCall(TCharm::nodeInit,1);
}
#endif

#ifndef CK_TEMPLATES_ONLY
void _registertcharm(void)
{
  static int _done = 0; if(_done) return; _done = 1;
/* REG: message TCharmInitMsg{
char data[];
}
;
*/
CMessage_TCharmInitMsg::__register("TCharmInitMsg", sizeof(TCharmInitMsg),(CkPackFnPtr) TCharmInitMsg::pack,(CkUnpackFnPtr) TCharmInitMsg::unpack);

/* REG: array TCharm: ArrayElement{
TCharm(CkMigrateMessage* impl_msg);
TCharm(TCharmInitMsg* impl_msg);
void atBarrier(CkReductionMsg* impl_msg);
void atExit(CkReductionMsg* impl_msg);
void migrateDelayed(int destPE);
void start(void);
void callSystem(const callSystemStruct &s);
  initcall void procInit(void);
  initcall void nodeInit(void);
};
*/
  CkIndex_TCharm::__register("TCharm", sizeof(TCharm));

}
#endif
